
/*
ShaMan Hash Shared Library (SHA1 SHA256 SHA384 SHA512 MD5 BASE64 + random string generator )
Copyright (c) 2007 James Mrad (xtremejames183@msn.com)

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "shaman.h"

int	main(int argc,char	*argv[])
{

	SHAMAN_CTX	*SCT; /* Context ShaMan */
	int res ;
	uint8_t	test[512];
	int i;
	char HAMETH[6][10] = { "SHA1","SHA256","SHA384","SHA512","MD5","BASE64" } ;
	char a[512];
	/* Init Shaman Library*/

	SCT = InitShaMan() ;
	
	if( SCT == NULL)
	{
		puts("Cannot Load ShaMan Library");
		exit(EXIT_FAILURE);
	}
	puts(SCT->version);
	
	/* genrate a random String */
	res = GenRandomString(test,17);
	if(res != SHAMAN_OK)
	{
		puts("Cannot Generate Random String");
		exit(EXIT_FAILURE);
	}
	printf("Random String is %s\n\n",test);


	/* prepare to hash */
	ShaManAdd(SCT,"bonjour");

	/* core hash module */
	//for(i = 0 ; i<= BASE64_HASH ; i++ )
	//{
	SCT->meth = 5 ;
	res = ShaManHashData(SCT);

	if(res != SHAMAN_OK)
	{
		puts("Error While Hasing Data");
		//continue ;
	}
	printf("%s Hex Code is:\n\t %s\n\n",HAMETH[5],SCT->hash);

	//}

	SCT->meth = SHA1_HASH;
	ShaManFileCheckSum(SCT,"./license.txt");
	printf("License.txt Checksum(SHA1): %s\n",SCT->hash);
	SCT->meth = SHA256_HASH;
	ShaManFileCheckSum(SCT,"./license.txt");
	printf("License.txt Checksum(SHA256): %s\n",SCT->hash);
	SCT->meth = MD5_HASH;
	ShaManFileCheckSum(SCT,"./license.txt");
	printf("License.txt Checksum(MD5): %s\n",SCT->hash);

	//ShaCryptString("test");
	//ShaCryptString("bonjour", 1);
	//printf("\n\n %s \n", a);
	//ShaCryptString(*a,"bonjour", 1);
	//printf("\n\n %s \n", a);
	//SCT->hash = "bnjouy";
	//printf("\n\n %s \n", ShaCryptString("bonjour", 1));
	DestroyShaMan(SCT);

	system("PAUSE");
	return 0;
}